package fractaltree;
import java.awt.*;
import javax.swing.*;

public class Main extends JPanel {
    int SIZEX=800;
    int SIZEY=600;
    double angle1=14;
    double angle2=14;
    
    /** Creates a new instance of Main */
    public Main() {
        setPreferredSize(new Dimension(SIZEX, SIZEY));
        JFrame theFrame = new JFrame();
        theFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        // show the panel + frame !
        theFrame.getContentPane().add(this);
        theFrame.pack();
        theFrame.setVisible(true);
    }
  
    public void paintComponent(Graphics g){
        g.setColor(Color.BLACK);
        g.fillRect(0,0,SIZEX, SIZEY);
        drawTreeRecursive(g,SIZEX/2,10,100.0,0.0);
    }
    
    public void drawTreeRecursive(Graphics g, int x, int y, double size, double angle){
        if (size<10) return;
        else{
            Point t1=Branch.getTip1(x,y,size,angle);
            Point t2=Branch.getTip2(x,y,size,angle);
            
            angle1=angle1+Math.random()*0.1-0.05;
            angle2=angle2+Math.random()*0.1-0.05;
            drawTreeRecursive(g,t1.x,t1.y,size/1.2,angle-angle1);
            drawTreeRecursive(g,t2.x,t2.y,size/1.2,angle+angle2);
            
            
            Branch.drawBranch(g,x,y,size,angle,SIZEY);
            return;
        }   
    }
    
    public static void main(String[] args) {
        Main m=new Main();
        while(true){
            try {
                
                Thread.sleep(50);
            } catch (InterruptedException ex) {
                ex.printStackTrace();
            }
            Branch.spread=10+(Math.random()-0.5)*10;
            m.repaint();
        }
    }    

}
